/* --> TESSELATIONPATCH */

#ifndef ONCE_TESSELAT_H_
#define ONCE_TESSELAT_H_

#include "frame.h"
#include "mem.h"
#include "parse.h"
#include "tokenize.h"
#include "mesh.h"

OBJECT* Parse_Tesselation(void);
OBJECT* Parse_Tessel(void);

void Parse_Tesselation_In_Mesh(MESH* m, MESH_TRIANGLE** trs,TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int *m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int *n_tex,int* n_vert,int* n_norm);
void Parse_Tessel_In_Mesh(MESH* m, MESH_TRIANGLE** trs,TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int *m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int *n_tex,int* n_vert,int* n_norm);

OBJECT* Parse_Bourke(void);
OBJECT* Parse_Heller(void);

void Parse_Bourke_In_Mesh(MESH* m, MESH_TRIANGLE** trs,TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int *m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int *n_tex,int* n_vert,int* n_norm);
void Parse_Heller_In_Mesh(MESH* m, MESH_TRIANGLE** trs,TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int *m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int *n_tex,int* n_vert,int* n_norm);

void Parse_Get_Vertex(VECTOR Vect);
void Parse_Get_Normal(VECTOR Vect);
void Parse_Get_Vertex_Indices(VECTOR Vect);
void Parse_Get_Normal_Indices(VECTOR Vect);

DBL Parse_Get_Triangles_Amount(void);
DBL Parse_Get_Vertices_Amount(void);
DBL Parse_Get_Normals_Amount(void);
DBL Parse_Is_Smooth_Triangle(void);

/*
POV_ARRAY* Parse_Get_Vertices(void);
POV_ARRAY* Parse_Get_Triangles(void);
POV_ARRAY* Parse_Get_Normals(void);
*/

OBJECT* Parse_Cubicle(void);
OBJECT* Parse_Select(void);

void Parse_Cubicle_In_Mesh(MESH* m, MESH_TRIANGLE** trs,TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int *m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int *n_tex,int* n_vert,int* n_norm);

void Parse_Select_In_Mesh(MESH* m, MESH_TRIANGLE** trs,TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int *m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int *n_tex,int* n_vert,int* n_norm);

OBJECT* Parse_Grid(void);

OBJECT* Parse_Cristal(void);

void Parse_Cristal_In_Mesh(MESH* m, MESH_TRIANGLE** trs, TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int *m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int* n_tex,int* n_vert,int* n_norm);


OBJECT* Parse_Screw(void);

void Parse_Screw_In_Mesh(MESH* m, MESH_TRIANGLE** trs, TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int* full,
                               int* m_tri,int* m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int* n_tex,int* n_vert,int* n_norm);

OBJECT* Parse_Roll(void);

void Parse_Roll_In_Mesh(MESH* m, MESH_TRIANGLE** trs, TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int* m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int* n_tex,int* n_vert,int* n_norm);

OBJECT* Parse_Bend(void);
OBJECT* Parse_Displace(void);
OBJECT* Parse_Move_Object(void);
OBJECT* Parse_Warp_Object(void);

void Parse_Warp_In_Mesh(MESH* m, MESH_TRIANGLE** trs, TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int* m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int* n_tex,int* n_vert,int* n_norm);

void Parse_Bend_In_Mesh(MESH* m, MESH_TRIANGLE** trs, TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int* m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int* n_tex,int* n_vert,int* n_norm);

void Parse_Displace_In_Mesh(MESH* m, MESH_TRIANGLE** trs, TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int* m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int* n_tex,int* n_vert,int* n_norm);

void Parse_Move_In_Mesh(MESH* m, MESH_TRIANGLE** trs, TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms,int *full,
                               int* m_tri,int* m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int* n_tex,int* n_vert,int* n_norm);

OBJECT* Parse_Smooth(void);

void Parse_Smooth_In_Mesh(MESH* m, MESH_TRIANGLE** trs, TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms, int *full,
                               int* m_tri,int* m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int* n_tex,int* n_vert,int* n_norm);

void Parse_Gts_Save(void);
OBJECT* Parse_Gts_Load(void);

void Parse_Load_In_Mesh(MESH* m, MESH_TRIANGLE** trs, TEXTURE*** textu,
                               SNGL_VECT** verts, SNGL_VECT** norms, int *full,
                               int* m_tri,int* m_tex,int* m_vert,int* m_norm,
                               int* n_tri,int* n_tex,int* n_vert,int* n_norm);

#endif

/* TESSELATIONPATCH <-- */
